#include "cddalist.h"


unsigned int tracks_cdda;

cddalist::cddalist(QWidget *parent, const char *name, TodoList *tdlist ) : QWidget(parent, name) { 	initMetaObject();
	initLayout();
	todolist_p =tdlist;

	void initLayout(void);

	cdda2cdr_list.setExecutable ( "cdparanoia" );
	cdda2cdr_list << "-Q" << "-d" << todolist_p->device_choiced;
	connect(&cdda2cdr_list, SIGNAL(processExited(KProcess *)), SLOT(cdda2cdr_list_dead(KProcess *)));
	connect(&cdda2cdr_list, SIGNAL(receivedStderr(KProcess *, char *, int )), this, SLOT(cdda2cdr_list_stdout_read(KProcess *, char *, int  )));
	connect( QPushButton_ok, SIGNAL(clicked()), SLOT(QPushButton_ok_clicked( )) );
	connect( QPushButton_takeall, SIGNAL(clicked()), SLOT(QPushButton_takeall_clicked()) );
	connect( QPushButton_cancel, SIGNAL(clicked()), SLOT(QPushButton_cancel_clicked()) );
	cdda2cdr_list.start(KProcess::Block, KProcess::AllOutput);

        resize( 349, 440 );
        setFixedSize( 349, 440 );     
};

cddalist::~cddalist() 
{

};

void cddalist::closeEvent( QCloseEvent *e )
{
	e->accept();
	emit destroy_cddalist();
};

void cddalist::cdda2cdr_list_dead(KProcess *)
{
	;
}

void cddalist::QPushButton_cancel_clicked()
{
	emit destroy_cddalist();
}

void cddalist::QPushButton_takeall_clicked()
{
	unsigned int h, i;
	long int  j;
	QString temp;
	char temp2[10];
	temp = "123456";
	const char *temp_p = temp;

	for (i = 1; i <= todolist_p->tracks_cdda; i++)
	{
		todolist_p->tracks++;
		todolist_p->tracknumber[todolist_p->tracks] = i; 
		todolist_p->device[todolist_p->tracks] = todolist_p->device_choiced;
		todolist_p->time[todolist_p->tracks] = time[i];
		todolist_p->type[todolist_p->tracks] = 1;
		todolist_p->title[todolist_p->tracks] = "";
		todolist_p->year[todolist_p->tracks] = "";
		todolist_p->comment[todolist_p->tracks] = "";
		todolist_p->group[todolist_p->tracks] = "";
		todolist_p->album[todolist_p->tracks] = "";
                temp = nodes[i];
		temp_p = temp;
		j = 0;
		for ( h=0; h<=6 ; h++)
		{
			if ( *temp_p >= 48 &&  *temp_p <=57 ) 
			{
				j += *temp_p++ + j + (j<<3) - 48;
			}
			else
				temp_p++;
		}
		todolist_p->nodes[todolist_p->tracks] = j;
		ostrstream( temp2, 10) << i << ends;
		temp = temp2;
		if ( i< 10 )
			temp = "0" + temp;
		todolist_p->output_filename[todolist_p->tracks] = "KrabberFile" + temp;
		todolist_p->music_type[todolist_p->tracks] = 99;
	};

	emit destroy_cddalist();
}

void cddalist::QPushButton_ok_clicked()
{
	unsigned int h, i;
	long int  j;
	QString temp;
	char temp2[10];
	temp = "123456";
	const char *temp_p = temp;


	for (i = 1; i <= todolist_p->tracks_cdda; i++)
	{
		if ( QListBox_CDDA->isSelected( i - 1 )  )
		{
			todolist_p->tracks++;
			todolist_p->tracknumber[todolist_p->tracks] = i;
			todolist_p->device[todolist_p->tracks] = todolist_p->device_choiced;
			todolist_p->time[todolist_p->tracks] = time[i]; 
                        temp = nodes[i];
			temp_p = temp;
			j = 0;
			for ( h=0; h<=6 ; h++)
			{
				if ( *temp_p >= 48 &&  *temp_p <=57 ) 
				{
					j += *temp_p++ + j + (j<<3) - 48;
				}
				else
					temp_p++;
			}
			todolist_p->nodes[todolist_p->tracks] = j;
			todolist_p->type[todolist_p->tracks] = 1;
			todolist_p->title[todolist_p->tracks] = "";
			todolist_p->year[todolist_p->tracks] = "";
			todolist_p->comment[todolist_p->tracks] = "";
			todolist_p->group[todolist_p->tracks] = "";
			todolist_p->album[todolist_p->tracks] = "";
			ostrstream( temp2, 10) << todolist_p->tracks << ends;
			temp = temp2;
			if ( i< 10 )
				temp = "0" + temp;
			todolist_p->output_filename[todolist_p->tracks] = "KrabberFile" + temp;
			todolist_p->music_type[todolist_p->tracks] = 99;
 		};
	};

	emit destroy_cddalist();
}

void cddalist::cdda2cdr_list_stdout_read(KProcess *, char *buffer, int buffer_size) 
{
 	QString row;
	QString temp;
	char temp2[10];
	int i;
	unsigned int ui;
	temp = buffer; 
	todolist_p->tracks_cdda = 0;
	
	if (buffer_size > 1023)
	{
		cddalist_temp = cddalist_temp + temp.mid(0, 1024);
	}
	else
	{
		cddalist_temp = cddalist_temp + temp.mid(0, (buffer_size - 1));
		if ( !cddalist_temp.contains( "  1.  " ) )
		{
                       KMsgBox::message( this, "CD Error", "No audiotracks found.");
		       return;
		}

		cddalist_temp = cddalist_temp.mid( cddalist_temp.find ("  1. " ) ,(cddalist_temp.length() - cddalist_temp.find ("  1. " ) - 1) );
		todolist_p->tracks_cdda = (cddalist_temp.length() / 59) + 1;
		for (ui = 1; ui <= todolist_p->tracks_cdda; ui++)
		{
			i = ui;
			ostrstream( temp2, 10) << i <<ends;
			row = temp2;
			time[i]  = cddalist_temp.mid(59*i - 44, 8);
			nodes[i] = cddalist_temp.mid(59*i - 52, 6);
			if ( i< 10 )
				row = "0" + row + ". Track: " + time[i];
 			else
				row = row + ". Track: " + time[i];
			QListBox_CDDA->insertItem(row);
		};
	};
};



















